<?php

/**
* Clase Dispacher para Egreso
*
* @package IM
* @subpackage EgresoDP
* @author Willy
* @version SVN: : EgresoDP.class.php,v 1.1 2009/05/22 10:08:49 Exp $
*/
class EgresoDP implements interfaceDP {
	private static $fieldNames = array (
    'Descripcion' => 'Descripcion'
	);
  protected $o_Bean;

  /**
  * Constructor donde asigna a un atributo el objeto EgresoBean
  *
  * @param EgresoBean $o_EgresoBean
  */
  public function __construct(EgresoBean $o_EgresoBean){
  
    $this->o_Bean = $o_EgresoBean;
    
  }
  
  /**
  * Retorna el objeto EgresoBean
  *
  * @return Object
  */
  protected function getObjetoBean(){
  
    if(!$this->o_Bean){
        $this->o_Bean = new EgresoBean();
    }        
    return $this->o_Bean;
    
  }
  
  /**
  * Ingresa un nuevo registro
  *
  * @return IdGenerado
  */
  
  public function save(){
    $con = Conexion::getConexion();
      $a_Fields = array();
      if($this->getObjetoBean()->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getObjetoBean()->getDescripcion()); endif;
      if($this->getObjetoBean()->getEstado()) : $a_Fields['Estado'] = ($this->getObjetoBean()->getEstado()); endif;
      if($this->getObjetoBean()->getTipoEgreso()) : $a_Fields['TipoEgreso'] = ($this->getObjetoBean()->getTipoEgreso()); endif;
      if($this->getObjetoBean()->getEliminado()) : $a_Fields['Eliminado'] = ($this->getObjetoBean()->getEliminado()); endif;
      if($this->getObjetoBean()->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getObjetoBean()->getUsuarioCreacion()); endif;
      if($this->getObjetoBean()->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getObjetoBean()->getFechaCreacion()); endif;
      if($this->getObjetoBean()->getUsuarioModificacion()) : $a_Fields['UsuarioModificacion'] = ($this->getObjetoBean()->getUsuarioModificacion()); endif;
      if($this->getObjetoBean()->getFechaModificacion()) : $a_Fields['FechaModificacion'] = ($this->getObjetoBean()->getFechaModificacion()); endif;
      if($this->getObjetoBean()->getFechaEliminado()) : $a_Fields['FechaEliminado'] = ($this->getObjetoBean()->getFechaEliminado()); endif;
      if($this->getObjetoBean()->getUsuarioEliminado()) : $a_Fields['UsuarioEliminado'] = ($this->getObjetoBean()->getUsuarioEliminado()); endif;
      
      $sStringField = arrayClass::implode_keys(',', $a_Fields);
      $sStringValue = "'".implode("','", $a_Fields)."'";

      $sql = "INSERT INTO cr_egreso (".$sStringField.")
                      VALUES (".$sStringValue.");";
       //echo $sql;
      $iResultSave = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      mysql_close($con);
      if($iResultSave > 0){
        return $iResultSave;
      }else{
        return false;
      }
  
  }
  
  
  /**
  * Modifica un nuevo registro
  *
  * @return IdGenerado
  */
  
   public function update() {

    if($this->getObjetoBean()->getIdEgreso()){
      $con = Conexion::getConexion();
      $a_Fields = array();
      if($this->getObjetoBean()->getIdEgreso()) : $a_Fields['IdEgreso'] = ($this->getObjetoBean()->getIdEgreso()); endif;
      if($this->getObjetoBean()->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getObjetoBean()->getDescripcion()); endif;
      if($this->getObjetoBean()->getEstado()) : $a_Fields['Estado'] = ($this->getObjetoBean()->getEstado()); endif;
      if($this->getObjetoBean()->getTipoEgreso()) : $a_Fields['TipoEgreso'] = ($this->getObjetoBean()->getTipoEgreso()); endif;
      if($this->getObjetoBean()->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getObjetoBean()->getUsuarioCreacion()); endif;
      if($this->getObjetoBean()->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getObjetoBean()->getFechaCreacion()); endif;
      if($this->getObjetoBean()->getUsuarioModificacion()) : $a_Fields['UsuarioModificacion'] = ($this->getObjetoBean()->getUsuarioModificacion()); endif;
      if($this->getObjetoBean()->getFechaModificacion()) : $a_Fields['FechaModificacion'] = ($this->getObjetoBean()->getFechaModificacion()); endif;
      if($this->getObjetoBean()->getFechaEliminado()) : $a_Fields['FechaEliminado'] = ($this->getObjetoBean()->getFechaEliminado()); endif;
      if($this->getObjetoBean()->getUsuarioEliminado()) : $a_Fields['UsuarioEliminado'] = ($this->getObjetoBean()->getUsuarioEliminado()); endif;
      
      $sString = arrayClass::implode_key_value(",", $a_Fields);

      $sql = "UPDATE cr_egreso SET
                  ".$sString."
            WHERE 1 AND IdEgreso= '".$this->getObjetoBean()->getIdEgreso()."' ";
      
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      mysql_close($con);
      //echo $sql;           
      $iResultSave = $result;
      if($iResultSave > 0){
        return $iResultSave;
      }else{
        return false;
      }

    }else{
      return false;
    }

  }
  
  
  /**
  * Elimina registro
  *
  * @return Boolean
  */
 public function delete(){
    
      $o_Egreso = new EgresoBean();
      
      $con = Conexion::getConexion();
      
      if($this->getObjetoBean()->getIdEgreso()){
          $o_Egreso->setIdEgreso($this->getObjetoBean()->getIdEgreso());
      }
            
      $sql = "UPDATE cr_egreso 
              SET
                Eliminado = '1',
                FechaEliminado = '".date('Y-m-d H:i:s')."',
                UsuarioEliminado = '".$this->getObjetoBean()->getUsuarioEliminado()."'
            WHERE IdEgreso = '".$this->getObjetoBean()->getIdEgreso()."' ";
      
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
     // echo $sql;
     // exit();
      $num_rows = mysql_affected_rows($con);
      mysql_close($con);
                  
      $iResultDelete = $num_rows;
      if($iResultDelete){
          return 1;
      }else{
          return false;
      }    
    
  }
  /**
  * Selecciona un nuevo registro
  *
  * @return IdGenerado
  */
  public function select(){
      
    $where = "";
        
    $tamPag           = is_null($this->getObjetoBean()->tamPag)?999999:$this->getObjetoBean()->tamPag;
    $pagina           = is_null($this->getObjetoBean()->page)?1:$this->getObjetoBean()->page;
    $numeroRegistros  = $this->selectNumRows();
    $limitInf         = ($pagina-1)*$tamPag;
    
    $where = $this->buildConsult();
    $orden = $this->buildOrderByField();
    if(trim($orden) =='') $orden = "ORDER BY IdEgreso DESC";
    $con = Conexion::getConexion();
    $sql = "SELECT * FROM cr_egreso
            WHERE Eliminado <> '1' ".$where." ".$orden." LIMIT ".$limitInf.",".$tamPag;
    //echo $sql;
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
    //echo $sql;
    $a_tmp = array();

    if($num_rows>0){
      while ($o_valor = mysql_fetch_object($result)) {
      $a_tmp[] = $this->insertarObjetoBean($o_valor);
      }
    }

    mysql_close($con);
   
    return count($a_tmp)>0?$a_tmp:null;
      
  }  
  
  
  /**
  * Retorna un objeto EgresoBean
  *
  * @return Object
  */
  public function selectByPk(){
  
    $con = Conexion::getConexion();
    $sql = "SELECT * FROM cr_egreso WHERE 1 and IdEgreso='".$this->getObjetoBean()->getIdEgreso()."' ";
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $o_Propel = $result ? mysql_fetch_object($result) : null;
    mysql_close($con);

    return $o_Propel?$this->insertarObjetoBean($o_Propel):null;
  
  }
  
  public function buildOrderByField(){
    $order_by = "";
    if($this->getObjetoBean()->sortCampos || $this->getObjetoBean()->sortCampos != ""){
      $a_valCampos = explode(";", $this->getObjetoBean()->sortCampos);
      $a_valtype   = explode(";", $this->getObjetoBean()->sortType);
      $order_by = " ORDER BY ";
      $a_order = array();
      foreach ($a_valCampos as $key => $val){
        $sTmpOrder = "";
        if(array_key_exists($val, self::$fieldNames)){
          $sTmpOrder .= self::$fieldNames[$val];
          switch ($a_valtype[$key]){
            case 1: $sTmpOrder .= " ASC"; break;
            case 2: $sTmpOrder .= " DESC"; break;
          }
          $a_order[] = $sTmpOrder;
        }
      }
      $order_by .= implode(", ", $a_order);
    }
    return $order_by;
  }
  
  /**
  * Reasigna valores retornados del propel a un objeto EgresoBean
  *
  * @param Object $o_Propel
  * @return EgresoBean
  */
  private function insertarObjetoBean($o_Propel){

    $o_EgresoBean = new EgresoBean();
    
    $o_EgresoBean->setIdEgreso($o_Propel->IdEgreso);
    $o_EgresoBean->setDescripcion($o_Propel->Descripcion);
    $o_EgresoBean->setEstado($o_Propel->Estado);
    $o_EgresoBean->setTipoEgreso($o_Propel->TipoEgreso);
    $o_EgresoBean->setEliminado($o_Propel->Eliminado);
    $o_EgresoBean->setUsuarioCreacion($o_Propel->UsuarioCreacion);
    $o_EgresoBean->setFechaCreacion($o_Propel->FechaCreacion);
    $o_EgresoBean->setUsuarioModificacion($o_Propel->UsuarioModificacion);
    $o_EgresoBean->setFechaModificacion($o_Propel->FechaModificacion);
    $o_EgresoBean->setFechaEliminado($o_Propel->FechaEliminado); 
    $o_EgresoBean->setUsuarioEliminado($o_Propel-> UsuarioEliminado);   
    $o_EgresoBean->setNoEditable($o_Propel-> noeditable);   
    
    return $o_EgresoBean;    
    
  }

   public function selectNumRows(){
    
    $where = $this->buildConsult();
    
    $con = Conexion::getConexion();
    
    $sql = "SELECT * FROM cr_egreso WHERE Eliminado <> '1'".$where;
   
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
    
    mysql_close($con);
    //echo $sql;
    return $num_rows;
    
  }
  
   private function buildConsult(){
    
    $where = "";
    
    if($this->getObjetoBean()->getIdEgreso()){
       $where .= " AND IdEgreso  = '".$this->getObjetoBean()->getIdEgreso ()."'";
    }
    
    if($this->getObjetoBean()->getDescripcion()){
       $where .= " AND Descripcion like '%".$this->getObjetoBean()->getDescripcion()."%'";
    }
    if($this->getObjetoBean()->getEstado()){
        $where .= " AND Estado  = '".$this->getObjetoBean()->getEstado()."'";
    }/*
    if($this->getObjetoBean()->getApellidoMaterno()){
       $where .= " AND ApellidoMaterno like '".$this->getObjetoBean()->getApellidoMaterno()."%'";
    }
	 if($this->getObjetoBean()->getDni()){
       $where .= " AND dni like '".$this->getObjetoBean()->getDni()."%'";
    }*/
    return $where;
    
  }
   
}


